
Unit mainUni1;

{$mode objfpc}{$H+}

Interface

Uses
Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
StdCtrls, process, about;

Type

  { TMainForm }

  TMainForm = Class(TForm)
    AboutButton: TButton;
    CompressButton: TButton;
    PackMemo: TMemo;
    OpenDialog: TOpenDialog;
    aProcess: TProcess;
    ProgressMemo: TMemo;
    QuitButton: TButton;
    SelectButton: TButton;
    procedure AboutButtonClick(Sender: TObject);
    Procedure CompressButtonClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure QuitButtonClick(Sender: TObject);
    Procedure SelectButtonClick(Sender: TObject);
    Private
    { private declarations }
    Public
    { public declarations }
    Procedure FileCopy(Const FSrc, FDst: String);
  End;

Var
  MainForm: TMainForm;
  Candidate : String;
  F: File Of char;
  cmd : String;

  Implementation

{ TMainForm }


Procedure TMainForm.FormCreate(Sender: TObject);
Begin
  ProgressMemo.Lines.Clear;
  PackMemo.Lines.Clear;
End;


Procedure TMainForm.CompressButtonClick(Sender: TObject);

Var
  stripped : Integer;
  final : Integer;
  fin : Extended;
Begin
  Try
    aProcess := TProcess.Create(Nil);
    cmd := 'strip --verbose --strip-all "'+ Candidate +'"';
    ProgressMemo.Lines.Add(cmd);
    aProcess.CommandLine := cmd;
    aProcess.Options := aProcess.Options + [poWaitOnExit, poNoConsole, poUsePipes];
    aProcess.Execute;
    ProgressMemo.Lines.LoadFromStream(aProcess.Output);
  Finally
    aProcess.Free;
  End;
  ProgressMemo.Lines.Add('');
  ProgressMemo.Lines.Add('');

  Try
    AssignFile(F,Candidate);
    Reset(F);
    stripped := FileSize(F);
    ProgressMemo.Lines.Add('STRIPPED SIZE : ' + IntToStr(stripped));
    ProgressMemo.Lines.Add('');
  Finally
    CloseFile(F);
  End;

  Try
    aProcess := TProcess.Create(Nil);
    cmd := 'upx -9 -qv "'+ Candidate +'"';
    PackMemo.Lines.Add(cmd);
    aProcess.CommandLine := cmd;
    aProcess.Options := aProcess.Options + [poWaitOnExit, poNoConsole, poUsePipes];
    aProcess.Execute;
    PackMemo.Lines.LoadFromStream(aProcess.Output);
  Finally
    aProcess.Free;
  End;



  Try
    AssignFile(F,Candidate);
    Reset(F);
    final := FileSize(F);
    PackMemo.Lines.Add('');
    PackMemo.Lines.Add('FINAL EXECUTABLE SIZE: '+IntToStr(final));
  Finally
    CloseFile(F);
  End;
  CompressButton.Enabled := false;
  fin := final / 1048576;
  If final < stripped Then ShowMessage('Compression complete. Final Size ' + FloatToStrF(fin,
                                       ffNumber, 4,2) + 'MB');
End;

procedure TMainForm.AboutButtonClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

Procedure TMainForm.QuitButtonClick(Sender: TObject);
Begin
  Close;
End;

Procedure TMainForm.SelectButtonClick(Sender: TObject);

Var
  nam : String;
  dir : String;
Begin
  ProgressMemo.Lines.Clear;
  If OpenDialog.Execute Then
    Begin
      Candidate := OpenDialog.FileName;
      ProgressMemo.Lines.Add('FILE : ' + Candidate);
      dir := ExtractFilePath(Candidate);
      nam := ExtractFileName(Candidate);
      dir := dir + 'original';
      If Not DirectoryExists(dir) Then
        CreateDir(dir);

      dir := dir + '/' + nam;
      Try
        FileCopy(Candidate, dir);
        AssignFile(F,dir);
        Reset(F);
        ProgressMemo.Lines.Add('CURRENT SIZE : ' + IntToStr(FileSize(F)));
        ProgressMemo.Lines.Add('');

      Finally
        CloseFile(F);
      End;
      CompressButton.Enabled := true;
    End;
  //Candidate := dir;
End;

Procedure TMainForm.FileCopy(Const FSrc, FDst: String);

Var
  sStream,
  dStream: TFileStream;
Begin
  sStream := TFileStream.Create(FSrc, fmOpenRead);
  Try
    dStream := TFileStream.Create(FDst, fmCreate);
    Try
      {Forget about block reads and writes, just copy
       the whole thing.}
      dStream.CopyFrom(sStream, 0);
    Finally
      dStream.Free;
    End;
  Finally
    sStream.Free;
  End;
End;

initialization
  {$I mainuni1.lrs}

End.

